from rest_framework import serializers

from ..models import Sound

__all__ = ("SoundSerializer", "PodcastSerializer")


class SoundSerializer(serializers.ModelSerializer):
    file = serializers.FileField(use_url=False)
    type_display = serializers.SerializerMethodField()

    class Meta:
        model = Sound
        fields = [
            "pk",
            "name",
            "program",
            "episode",
            "type",
            "type_display",
            "file",
            "duration",
            "mtime",
            "is_good_quality",
            "is_public",
            "is_downloadable",
            "url",
        ]

    def get_type_display(self, obj):
        return obj.get_type_display()


class PodcastSerializer(serializers.ModelSerializer):
    # serializers.HyperlinkedIdentityField(view_name='sound', format='html')

    class Meta:
        model = Sound
        fields = [
            "pk",
            "name",
            "program",
            "episode",
            "type",
            "duration",
            "mtime",
            "url",
            "is_downloadable",
        ]
